//FehlendeDateien_CC_01d.js
// 06.06.2019 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Eventuell fehlende Dateien auflisten

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// das Auswhlen eines Ordners
var folderObj = File (Folder.selectDialog("Den Ordner auswhlen, welcher die\nzu prfenden Dokumente enthlt."));
var testObj = "" + folderObj;
if (testObj.match("null")) {
	exit();
}

// den Inhalt des Ordners auflisten ...
var tmpList = folderObj.getFiles("*.pdf");

// die Nummern auflisten ...
var nFiles = tmpList.length;
if (nFiles == 0) {
	alert ("Keine PDF-Datei gefunden.", "");
	exit();
}
else if (nFiles == 1) {
	alert ("Nur *eine* PDF-Datei vorhanden.", "");
	exit();
}
var numbersArr = [];
for (var n=0; n<nFiles; n++) {
	numbersArr[n] = tmpList[n].name.slice(0,3);
}
// ... und sortieren
numbersArr.sort(); 

// die Startnummer
var startNum = numbersArr[0]*1;
// die Endnummer
var stopNum = numbersArr[nFiles-1]*1;

// die Liste der fehlenden Nummern vorbereiten 
var missList = [];
// eine Schleife durch die Elemente 
for (var n=startNum+1; n<stopNum; n++) {
	// ein aktuelles Element zusammensetzen 
	var curItem = ("00" + n).slice(-3);
	// wenn sich das Element nicht in der Nummern-Liste befindet ...
	var isListed = checkArr(curItem, numbersArr, nFiles);
	if (isListed == false) {
		// ... dann wird es an die Liste "Fehlende Nummern" gehngt 
		missList.push(curItem);
	}
}

// die Liste prfen
var nMiss = missList.length;
if (nMiss > 0) {
	// den Report-String zusammensetzen
	if (nMiss == 1) {
		var missString = missList[0];
		var repString = "Fehlende Nummer:\r" + missString;
	}
	else {
		var missString = missList.join("\n");
		var repString = "Fehlende Nummern:\r" + missString;
	}
	// den Nummernstring mit InDesign anzeigen 
	var curDoc = app.documents.add();
	var resFrame = curDoc.textFrames.add({geometricBounds:[10,10,100,100]});
	resFrame.parentStory.contents = repString;
}
else {
	alert ("Die Dateien sind vollzhlig.", "");
}

//////////////////////////////////////////////////////////////////////////
function checkArr(curItem, numbersArr, nFiles) {
	for (var m=1; m<nFiles; m++) {
		if (curItem == numbersArr[m]) {
			return true;
		}
	}
	return false;
}